SystemOrganization addCategory: #Deprecated20!

!VirtualMachine class methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:42'!
vmFullPath
	self deprecated: 'use #fullPath' on:  '13 July 2012'  in: 'Pharo 2.0'.
	^ self fullPath! !

!VirtualMachine class methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:42'!
vmPath
	self deprecated: 'use #path' on:  '13 July 2012'  in: 'Pharo 2.0'.
	^ self path! !

Exception subclass: #ProgressInitiationException
	instanceVariableNames: 'workBlock maxVal minVal aPoint progressTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated20'!

!ProgressInitiationException commentStamp: '<historical>' prior: 0!
I provide a way to alter the behavior of the old-style progress notifier in String. See examples in:

ProgressInitiationException testWithout.
ProgressInitiationException testWith.
!

!ProgressInitiationException class methodsFor: 'signalling' stamp: 'ajh 1/22/2003 23:51'!
display: aString at: aPoint from: minVal to: maxVal during: workBlock

	^ self new
		display: aString at: aPoint from: minVal to: maxVal during: workBlock! !

!ProgressInitiationException methodsFor: 'action' stamp: 'CamilloBruni 8/30/2012 16:15'!
defaultAction

	^ UIManager default 
		displayProgress: progressTitle 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!ProgressInitiationException methodsFor: 'initialize-release' stamp: 'RAA 5/15/2000 11:43'!
display: argString at: argPoint from: argMinVal to: argMaxVal during: argWorkBlock

	progressTitle := argString.
	aPoint := argPoint.
	minVal := argMinVal.
	maxVal := argMaxVal.
	workBlock := argWorkBlock.
	^self signal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:06'!
maxVal
	^maxVal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:06'!
minVal
	^minVal! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:05'!
point
	^aPoint! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'JuanVuletich 10/28/2010 13:04'!
progressTitle
	^progressTitle! !

!ProgressInitiationException methodsFor: 'action' stamp: 'SeanDeNigris 6/21/2012 00:24'!
sendNotificationsTo: anObject

	self resume: (workBlock value: (anObject start: minVal; end: maxVal)).! !

!ProgressInitiationException methodsFor: 'accessing' stamp: 'pavel.krivanek 9/28/2006 20:31'!
workBlock 
	
	^ workBlock! !

!ProgressBarMorph methodsFor: '*Deprecated20' stamp: 'SeanDeNigris 5/22/2012 15:29'!
barSize: anInteger
	self deprecated: 'use #value: instead' on: '05/14/2012' in: 'Pharo 2.0'.
	
	value := anInteger.
	self changed.! !

!CompiledMethod methodsFor: '*deprecated20' stamp: 'MarcusDenker 4/29/2012 12:02'!
getSourceFor: selector in: class
	self deprecated: 'just use #sourceCode' on: '29 April 2012' in: 'Pharo 2.0'.
	^self sourceCode.! !

!JobProgressMorph methodsFor: '*Deprecated20' stamp: 'CamilloBruni 12/5/2012 22:00'!
value: anObject

	self deprecated: 'Use SystemProgressItemMorph''s "API" protocol' on: '20 June, 2012' in: 'Pharo 2.0'.
	
	(anObject isKindOf: Number) ifTrue: [ self current: anObject ].
	((anObject isKindOf: String) and: [ anObject isSymbol not ]) ifTrue: [ ^ self label: anObject ].
	anObject = #label ifTrue: [ ^ self label ].
	anObject = #increment ifTrue: [ ^ self increment ].
	anObject = #decrement ifTrue: [ ^ self decrement ].
	anObject = #setMax ifTrue: [ ^ self error: '#setMax no longer supported. File a bug report if you want it back' ].
	anObject = #setMin ifTrue: [ ^ self error: '#setMin no longer supported. File a bug report if you want it back' ].
	anObject = #stripe ifTrue: [ ^ self error: '#stripe no longer supported. File a bug report if you want it back' ].! !

TestCase subclass: #EventHandlerTest
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated20'!

!EventHandlerTest commentStamp: '<historical>' prior: 0!
An EventHandlerTest is a class made to test the behavior of EventHandler!

!EventHandlerTest methodsFor: 'running' stamp: ''!
setUp

	morph := Morph new.
	morph eventHandler: EventHandler new! !

!EventHandlerTest methodsFor: 'running' stamp: ''!
tearDown

	morph := nil! !

!EventHandlerTest methodsFor: 'tests' stamp: ''!
testClickFromMorph

	morph eventHandler on: #click send: #value to: true.
	
	self assert: ((morph click: nil) == true)! !

!EventHandlerTest methodsFor: 'tests' stamp: ''!
testDoubleClickFromMorph

	morph eventHandler on: #doubleClick send: #value to: true.
	
	self assert: ((morph doubleClick: nil) == true)! !

!EventHandlerTest methodsFor: 'tests' stamp: ''!
testDoubleClickTimeoutFromMorph

	morph eventHandler on: #doubleClickTimeout send: #value to: true.
	
	self assert: ((morph doubleClickTimeout: nil) == true)! !

!EventHandlerTest methodsFor: 'tests' stamp: 'GuillermoPolito 4/27/2012 10:01'!
testKeyStrokeFromMorph

	| keyboardEvent |
	keyboardEvent := KeyboardEvent new 
							setType: #keystroke
							buttons: 0
							position: 0@0
							keyValue: 65 "maybe"
							charCode: 97 "$a"
							hand: nil
							stamp: nil.

	morph eventHandler on: #keyStroke send: #value to: true.
	
	self assert: ((morph handleKeystroke: keyboardEvent) == true)! !

!EventHandlerTest methodsFor: 'tests-events' stamp: ''!
testMouseEnterDraggingFromMorph

	| event | 
	event := MouseEvent basicNew setType: #mouseOver position: nil buttons: 2 hand: Morph new.
	morph eventHandler on: #mouseEnterDragging send: #value to: true.
	
	self assert: ((morph handleMouseEnter: event) == true)! !

!EventHandlerTest methodsFor: 'tests-events' stamp: ''!
testMouseEnterFromMorph

	morph eventHandler on: #mouseEnter send: #value to: true.
	
	self assert: ((morph mouseEnter: nil) == true)! !

!EventHandlerTest methodsFor: 'tests-events' stamp: ''!
testMouseLeaveFromMorph

	morph eventHandler on: #mouseLeave send: #value to: true.
	
	self assert: ((morph mouseLeave: nil) == true)! !

!BlockClosure methodsFor: '*deprecated20' stamp: 'SeanDeNigris 8/30/2012 10:40'!
silentlyValue
	"evaluates the receiver but avoiding progress bar notifications to show up."
	self deprecated: 'dont use' on: 'Jul 2012'  in: '2.0'.
	^ self asJob
			loggingProgress;
			run.! !

!OSPlatform class methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:32'!
osVersion
	self deprecated: 'use Smalltalk os version' on:  '13 July 2012'  in: 'Pharo 2.0'.
	^ self version! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:33'!
documentPath
	"Answer the absolute path of the document passed to the vm or nil if none."
	self deprecated: 'use Smalltalk vm documentPath' on:  '13 July 2012'  in: 'Pharo 2.0'.
	
	^self vm documentPath! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:32'!
hasDisplay
	self deprecated: 'use isHeadless' on:  '13 July 2012'  in: 'Pharo 2.0'.
	^ self isHeadless not! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:32'!
isTrunk
	self deprecated: 'unused' on:  '13 July 2012'  in: 'Pharo 2.0'.

	^ (self version allButFirst: 5) anySatisfy: [ :char | char isLetter ]! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:33'!
osVersion
	"Return the operating system version"
	self deprecated: 'use Smalltalk os version' on:  '13 July 2012'  in: 'Pharo 2.0'.

	^self os version! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:31'!
platformName
	"Return the name of the platform we're running on"
	self deprecated: 'use Smalltalk os platformName' on:  '17 July 2012'  in: 'Pharo 2.0'.

	^ self platform name! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:31'!
platformSubtype
	"Return the subType of the platform we're running on"
	"Smalltalk platformSubtype"
	self deprecated: 'use Smalltalk os platformSubtype' on:  '17 July 2012'  in: 'Pharo 2.0'.

	^ self platform subtype! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:34'!
primVmPath
	"Answer the path for the directory containing the Smalltalk virtual machine. Return the empty string if this primitive is not implemented."
	"Smalltalk vmPath"
	<primitive: 142>

	self deprecated: 'use Smalltalk vm vmPath' on:  '13 July 2012'  in: 'Pharo 2.0'.


	^ ''! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:34'!
vmFullPath
	"Return the full vm path as a string"
	
	self deprecated: 'use Smalltalk vm fullPath' on:  '13 July 2012'  in: 'Pharo 2.0'.

	^self vm fullPath! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/17/2012 16:31'!
vmParameterAt: parameterIndex

	self deprecated: 'use Smalltalk vm parameterAt:' on:  '13 July 2012'  in: 'Pharo 2.0'.
	
	^ self vm parameterAt: parameterIndex! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:36'!
vmParameterAt: parameterIndex put: newValue
	self deprecated: 'use Smalltalk vm parameterAt:put:' on:  '13 July 2012'  in: 'Pharo 2.0'.
	
	^ self vm parameterAt: parameterIndex put: newValue! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:39'!
vmPath
	self deprecated: 'use Smalltalk vm path' on:  '13 July 2012'  in: 'Pharo 2.0'.

	^ self vm path
! !

!SmalltalkImage methodsFor: '*Deprecated20' stamp: 'MarcusDenker 7/13/2012 14:40'!
windowSystemName			
	"Return the name of the window system currently being used for display."
	self deprecated: 'use Smalltalk os windowSystemName' on:  '13 July 2012'  in: 'Pharo 2.0'.

	^ self os windowSystemName! !

!SystemProgressMorph methodsFor: '*Deprecated20' stamp: 'SeanDeNigris 8/29/2012 11:57'!
labelAt: aSystemProgressItemMorph put: aString
	"Change the label for the given progressBlock to aString."
	self deprecated: 'Send #label: directly to the progress item itself' on: '22 May 2012' in: 'Pharo 2.0'.
	
	aSystemProgressItemMorph label: aString.! !

!SystemProgressMorph methodsFor: '*Deprecated20' stamp: 'SeanDeNigris 5/23/2012 01:23'!
setLabel: shortDescription at: slot
	self deprecated: 'Use #label: directly on progress items instead' on: '22 May 2012' in: 'Pharo 2.0'.

	"There is no way to implement this in the new SystemProgressMorph. It doesn't make any sense because the items are not indexed"! !

!SystemProgressMorph methodsFor: '*Deprecated20' stamp: 'SeanDeNigris 5/22/2012 12:33'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	
	| fill |
	self deprecated: 'No senders in image' on: '22 May 2012' in: 'Pharo 2.0'.

	self theme preferGradientFill ifFalse: [^ self].
	fill := GradientFillStyle ramp: {0.0 -> Color white. 1 ->aColor}.
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

Object subclass: #EventHandler
	instanceVariableNames: 'mouseDownRecipient mouseDownSelector mouseMoveRecipient mouseMoveSelector mouseStillDownRecipient mouseStillDownSelector mouseUpRecipient mouseUpSelector mouseEnterRecipient mouseEnterSelector mouseLeaveRecipient mouseLeaveSelector mouseEnterDraggingRecipient mouseEnterDraggingSelector mouseLeaveDraggingRecipient mouseLeaveDraggingSelector keyStrokeRecipient keyStrokeSelector valueParameter startDragRecipient startDragSelector doubleClickSelector doubleClickRecipient doubleClickTimeoutSelector doubleClickTimeoutRecipient clickSelector clickRecipient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated20'!

!EventHandler commentStamp: '<historical>' prior: 0!
Events in Morphic originate in a Hand, pass to a target morph, and are then dispatched by an EventHandler.  EventHandlers support redirection of mouse and keyboard activity by specifying and independent recipient object and message selector for each of the possible events.  In addition each eventHandler can supply an optional value parameter for distinguishing between, eg, events from a number of otherwise identical source morphs.

The basic protocol of an event handler is to receive a message of the form
	mouseDown: event in: targetMorph
and redirect this as one of
	mouseDownRecipient perform: mouseDownSelector0
	mouseDownRecipient perform: mouseDownSelector1 with: event
	mouseDownRecipient perform: mouseDownSelector2 with: event with: targetMorph
	mouseDownRecipient perform: mouseDownSelector3 with: event with: targetMorph with: valueParameter
depending on the arity of the mouseDownSelector.
!

!EventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 17:33'!
allRecipients
	"Answer a list, without duplication, of all the objects serving as recipients to any of the events I handle.  Intended for debugging/documentation use only"
	| aList |
	aList := OrderedCollection with: mouseDownRecipient with: mouseStillDownRecipient with: mouseUpRecipient with: mouseEnterRecipient with: mouseLeaveRecipient.
	aList addAll: (OrderedCollection with:  mouseEnterDraggingRecipient with: mouseLeaveDraggingRecipient with: doubleClickRecipient with: keyStrokeRecipient).
	aList add: mouseMoveRecipient.
	^ (aList copyWithout: nil) asSet asArray! !

!EventHandler methodsFor: 'events' stamp: 'ar 10/7/2000 22:55'!
click: event fromMorph: sourceMorph 
	"This message is sent only when double clicks are handled."
	^ self
		send: clickSelector
		to: clickRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: 'LC 2/14/2000 08:38'!
doubleClick: event fromMorph: sourceMorph 
	^ self
		send: doubleClickSelector
		to: doubleClickRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: 'jcg 9/21/2001 13:06'!
doubleClickTimeout: event fromMorph: sourceMorph 
	^ self
		send: doubleClickTimeoutSelector
		to: doubleClickTimeoutRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!EventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 17:34'!
firstMouseSelector
	"Answer the selector corresponding to the first mouse-handling selector fielded.  Created in support of providing balloon-help for halo handles, triggered by the selector handled"

	mouseDownSelector ifNotNil: [^ mouseDownSelector].
	mouseMoveSelector ifNotNil:[^mouseMoveSelector].
	mouseStillDownSelector ifNotNil: [^ mouseStillDownSelector].
	mouseUpSelector ifNotNil: [^ mouseUpSelector].
	mouseEnterSelector ifNotNil: [^ mouseEnterSelector].
	mouseLeaveSelector ifNotNil: [^ mouseLeaveSelector].
	mouseEnterDraggingSelector ifNotNil: [^ mouseEnterDraggingSelector].
	mouseLeaveDraggingSelector ifNotNil: [^ mouseLeaveDraggingSelector].
	doubleClickSelector ifNotNil: [^ doubleClickSelector].
	^ nil! !

!EventHandler methodsFor: 'testing' stamp: 'ar 10/7/2000 22:56'!
handlesClickOrDrag: evt
	clickRecipient ifNotNil:[^true].
	doubleClickRecipient ifNotNil:[^true].
	startDragRecipient ifNotNil:[^true].
	^false! !

!EventHandler methodsFor: 'testing' stamp: 'nk 2/15/2004 08:57'!
handlesGestureStart: evt
	"Does the associated morph want to handle gestures?"
	^false! !

!EventHandler methodsFor: 'testing' stamp: 'ar 10/28/2000 22:17'!
handlesKeyboard: evt
	keyStrokeRecipient ifNotNil: [^ true].
	^ false! !

!EventHandler methodsFor: 'testing' stamp: 'nk 2/15/2004 08:13'!
handlesMouseDown: evt
	mouseDownRecipient ifNotNil: [^ true].
	mouseStillDownRecipient ifNotNil: [^ true].
	mouseUpRecipient ifNotNil: [^ true].
	(self handlesClickOrDrag: evt) ifTrue:[^true].
	^self handlesGestureStart: evt! !

!EventHandler methodsFor: 'testing' stamp: 'ar 10/25/2000 17:33'!
handlesMouseMove: evt
	^mouseMoveRecipient notNil and:[mouseMoveSelector notNil]! !

!EventHandler methodsFor: 'testing' stamp: ''!
handlesMouseOver: evt
	mouseEnterRecipient ifNotNil: [^ true].
	mouseLeaveRecipient ifNotNil: [^ true].
	^ false! !

!EventHandler methodsFor: 'testing' stamp: 'di 9/15/1998 16:35'!
handlesMouseOverDragging: evt
	mouseEnterDraggingRecipient ifNotNil: [^ true].
	mouseLeaveDraggingRecipient ifNotNil: [^ true].
	^ false! !

!EventHandler methodsFor: 'testing' stamp: 'ar 10/22/2000 17:05'!
handlesMouseStillDown: evt
	^mouseStillDownRecipient notNil and:[mouseStillDownSelector notNil]! !

!EventHandler methodsFor: 'events' stamp: ''!
keyStroke: event fromMorph: sourceMorph
	^ self send: keyStrokeSelector to: keyStrokeRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'access' stamp: ''!
messageList
	"Return a list of 'Class selector' for each message I can send. tk 
	9/13/97"
	| list |
	self flag: #mref.
	"is this still needed? I replaced the one use that I could spot with 
	#methodRefList "
	list := SortedCollection new.
	mouseDownRecipient
		ifNotNil: [list add: (mouseDownRecipient class whichClassIncludesSelector: mouseDownSelector) name , ' ' , mouseDownSelector].
	mouseMoveRecipient
		ifNotNil: [list add: (mouseMoveRecipient class whichClassIncludesSelector: mouseMoveSelector) name , ' ' , mouseMoveSelector].
	mouseStillDownRecipient
		ifNotNil: [list add: (mouseStillDownRecipient class whichClassIncludesSelector: mouseStillDownSelector) name , ' ' , mouseStillDownSelector].
	mouseUpRecipient
		ifNotNil: [list add: (mouseUpRecipient class whichClassIncludesSelector: mouseUpSelector) name , ' ' , mouseUpSelector].
	mouseEnterRecipient
		ifNotNil: [list add: (mouseEnterRecipient class whichClassIncludesSelector: mouseEnterSelector) name , ' ' , mouseEnterSelector].
	mouseLeaveRecipient
		ifNotNil: [list add: (mouseLeaveRecipient class whichClassIncludesSelector: mouseLeaveSelector) name , ' ' , mouseLeaveSelector].
	mouseEnterDraggingRecipient
		ifNotNil: [list add: (mouseEnterDraggingRecipient class whichClassIncludesSelector: mouseEnterDraggingSelector) name , ' ' , mouseEnterDraggingSelector].
	mouseLeaveDraggingRecipient
		ifNotNil: [list add: (mouseLeaveDraggingRecipient class whichClassIncludesSelector: mouseLeaveDraggingSelector) name , ' ' , mouseLeaveDraggingSelector].
	doubleClickRecipient
		ifNotNil: [list add: (doubleClickRecipient class whichClassIncludesSelector: doubleClickSelector) name , ' ' , doubleClickSelector].
	keyStrokeRecipient
		ifNotNil: [list add: (keyStrokeRecipient class whichClassIncludesSelector: keyStrokeSelector) name , ' ' , keyStrokeSelector].
	^ list! !

!EventHandler methodsFor: 'access' stamp: 'CamilloBruni 8/1/2012 16:11'!
methodRefList
	"Return a MethodReference for each message I can send."
	| list adder |
	list := SortedCollection new.
	adder := [:recip :sel | recip
				ifNotNil: [list
						add: (RGMethodDefinition
								realClass: (recip class whichClassIncludesSelector: sel)
								selector: sel)]].
	adder value: mouseDownRecipient value: mouseDownSelector.
	adder value: mouseMoveRecipient value: mouseMoveSelector.
	adder value: mouseStillDownRecipient value: mouseStillDownSelector.
	adder value: mouseUpRecipient value: mouseUpSelector.
	adder value: mouseEnterRecipient value: mouseEnterSelector.
	adder value: mouseLeaveRecipient value: mouseLeaveSelector.
	adder value: mouseEnterDraggingRecipient value: mouseEnterDraggingSelector.
	adder value: mouseLeaveDraggingRecipient value: mouseLeaveDraggingSelector.
	adder value: doubleClickRecipient value: doubleClickSelector.
	adder value: keyStrokeRecipient value: keyStrokeSelector.
	^ list! !

!EventHandler methodsFor: 'events' stamp: 'ar 10/7/2000 22:54'!
mouseDown: event fromMorph: sourceMorph 
	"Take double-clicks into account."
	((self handlesClickOrDrag: event) and:[event redButtonPressed]) ifTrue:[
		event hand waitForClicksOrDrag: sourceMorph event: event.
	].
	^self
		send: mouseDownSelector
		to: mouseDownRecipient
		withEvent: event
		fromMorph: sourceMorph.
! !

!EventHandler methodsFor: 'access' stamp: 'di 9/14/1998 08:32'!
mouseDownSelector
	^ mouseDownSelector! !

!EventHandler methodsFor: 'events' stamp: ''!
mouseEnter: event fromMorph: sourceMorph
	^ self send: mouseEnterSelector to: mouseEnterRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: 'di 9/15/1998 16:35'!
mouseEnterDragging: event fromMorph: sourceMorph
	^ self send: mouseEnterDraggingSelector to: mouseEnterDraggingRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: ''!
mouseLeave: event fromMorph: sourceMorph
	^ self send: mouseLeaveSelector to: mouseLeaveRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: 'di 9/15/1998 16:35'!
mouseLeaveDragging: event fromMorph: sourceMorph
	^ self send: mouseLeaveDraggingSelector to: mouseLeaveDraggingRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: 'ar 10/25/2000 17:32'!
mouseMove: event fromMorph: sourceMorph
	^ self send: mouseMoveSelector to: mouseMoveRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'events' stamp: ''!
mouseStillDown: event fromMorph: sourceMorph
	^ self send: mouseStillDownSelector to: mouseStillDownRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 18:27'!
mouseStillDownRecipient
	^mouseStillDownRecipient! !

!EventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 18:27'!
mouseStillDownSelector
	^mouseStillDownSelector! !

!EventHandler methodsFor: 'events' stamp: ''!
mouseUp: event fromMorph: sourceMorph
	^ self send: mouseUpSelector to: mouseUpRecipient withEvent: event fromMorph: sourceMorph! !

!EventHandler methodsFor: 'access' stamp: 'di 9/14/1998 08:32'!
mouseUpSelector
	^ mouseUpSelector! !

!EventHandler methodsFor: 'initialization' stamp: 'nk 2/15/2004 08:16'!
on: eventName send: selector to: recipient
	eventName == #mouseDown ifTrue:
		[mouseDownRecipient := recipient.  mouseDownSelector := selector. ^ self].
	eventName == #mouseMove ifTrue:
		[mouseMoveRecipient := recipient.  mouseMoveSelector := selector. ^ self].
	eventName == #mouseStillDown ifTrue:
		[mouseStillDownRecipient := recipient.  mouseStillDownSelector := selector. ^ self].
	eventName == #mouseUp ifTrue:
		[mouseUpRecipient := recipient.  mouseUpSelector := selector. ^ self].
	eventName == #mouseEnter ifTrue:
		[mouseEnterRecipient := recipient.  mouseEnterSelector := selector. ^ self].
	eventName == #mouseLeave ifTrue:
		[mouseLeaveRecipient := recipient.  mouseLeaveSelector := selector. ^ self].
	eventName == #mouseEnterDragging ifTrue:
		[mouseEnterDraggingRecipient := recipient.  mouseEnterDraggingSelector := selector. ^ self].
	eventName == #mouseLeaveDragging ifTrue:
		[mouseLeaveDraggingRecipient := recipient.  mouseLeaveDraggingSelector := selector. ^ self].
	eventName == #click ifTrue:
		[clickRecipient := recipient. clickSelector := selector. ^ self].
	eventName == #doubleClick ifTrue:
		[doubleClickRecipient := recipient. doubleClickSelector := selector. ^ self].
	eventName == #doubleClickTimeout ifTrue:
		[doubleClickTimeoutRecipient := recipient. doubleClickTimeoutSelector := selector. ^ self].
	eventName == #startDrag ifTrue:
		[startDragRecipient := recipient. startDragSelector := selector. ^ self].
	eventName == #keyStroke ifTrue:
		[keyStrokeRecipient := recipient.  keyStrokeSelector := selector. ^ self].
	eventName == #gesture ifTrue:
		[ ^self onGestureSend: selector to: recipient ].
	self error: 'Event name, ' , eventName , ' is not recognizable.'
! !

!EventHandler methodsFor: 'initialization' stamp: 'StephaneDucasse 10/20/2011 15:45'!
on: eventName send: selector to: recipient withValue: value
	selector numArgs = 3 ifFalse:
		[Halt halt: 'Warning: value parameters are passed as first of 3 arguments'].
	self on: eventName send: selector to: recipient.
	valueParameter := value
! !

!EventHandler methodsFor: 'initialization' stamp: 'nk 2/15/2004 08:59'!
onGestureSend: selector to: recipient! !

!EventHandler methodsFor: 'printing' stamp: 'nice 1/5/2010 15:59'!
printOn: aStream 
	| recipients |
	super printOn: aStream.
	#('mouseDownSelector' 'mouseStillDownSelector' 'mouseUpSelector' 'mouseEnterSelector' 'mouseLeaveSelector' 'mouseEnterDraggingSelector' 'mouseLeaveDraggingSelector' 'doubleClickSelector' 'keyStrokeSelector') 
		do: 
			[:aName | | aVal | 
			(aVal := self instVarNamed: aName) notNil 
				ifTrue: [aStream nextPutAll: '; ' , aName , '=' , aVal]].
	(recipients := self allRecipients) notEmpty 
		ifTrue: 
			[aStream nextPutAll: ' recipients: '.
			recipients printOn: aStream]! !

!EventHandler methodsFor: 'events' stamp: 'ar 3/17/2001 14:34'!
send: selector to: recipient withEvent: event fromMorph: sourceMorph
	| arity |
	recipient ifNil: [^ self].
	arity := selector numArgs.
	arity = 0 ifTrue:
		[^ recipient perform: selector].
	arity = 1 ifTrue:
		[^ recipient perform: selector with: event].
	arity = 2 ifTrue:
		[^ recipient perform: selector with: event with: sourceMorph].
	arity = 3 ifTrue:
		[^ recipient perform: selector with: valueParameter with: event with: sourceMorph].
	self error: 'Event handling selectors must be Symbols and take 0-3 arguments'! !

!EventHandler methodsFor: 'events' stamp: 'mir 5/23/2000 17:43'!
startDrag: event fromMorph: sourceMorph 
	^ self
		send: startDragSelector
		to: startDragRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!EventHandler methodsFor: 'copying' stamp: 'tk 1/22/2001 17:43'!
veryDeepFixupWith: deepCopier
	| old |
	"ALL inst vars were weakly copied.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
1 to: self class instSize do:
	[:ii | old := self instVarAt: ii.
	self instVarAt: ii put: (deepCopier references at: old ifAbsent: [old])].

! !

Object subclass: #LoggingSystemProgressItemMorph
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated20'!

!LoggingSystemProgressItemMorph methodsFor: 'compatibility' stamp: 'SeanDeNigris 8/30/2012 10:50'!
current: aNumber

	self log: start printString,'  ', end printString, '  ', aNumber printString.! !

!LoggingSystemProgressItemMorph methodsFor: 'compatibility' stamp: 'SeanDeNigris 6/21/2012 00:27'!
end: aNumber

	end := aNumber.! !

!LoggingSystemProgressItemMorph methodsFor: 'compatibility' stamp: 'SeanDeNigris 8/30/2012 10:50'!
log: aString

	self traceCr: aString.! !

!LoggingSystemProgressItemMorph methodsFor: 'callbacks' stamp: 'SeanDeNigris 8/30/2012 10:51'!
onChange: aJob

	self log: start printString,'  ', end printString, '  ', aJob currentValue printString.! !

!LoggingSystemProgressItemMorph methodsFor: 'callbacks' stamp: 'SeanDeNigris 8/30/2012 10:52'!
onEnd: aJob

	self log: aJob title, ' complete'.! !

!LoggingSystemProgressItemMorph methodsFor: 'callbacks' stamp: 'SeanDeNigris 8/30/2012 10:51'!
onStart: aJob

	self log: aJob title.! !

!LoggingSystemProgressItemMorph methodsFor: 'compatibility' stamp: 'SeanDeNigris 6/21/2012 00:27'!
start: aNumber

	start := aNumber.! !

!Object methodsFor: '*deprecated20' stamp: 'MarcusDenker 5/12/2012 01:11'!
flash
	self deprecated: 'only makes sense on Morph' on:  '12 May 2012'   in: 'Pharo 2.0' 
	"Do nothing."
! !

!ThumbnailImageMorph methodsFor: '*deprecated20' stamp: 'StephaneDucasse 4/22/2012 16:39'!
yesNoStringFor: aBool
	"Answer the string to be shown in a menu to represent the  
	yes/no status"
	self deprecated: 'use an Association instead of a string concatenation 'on: '22 April 2012' in: 'Pharo20'.
	^ (aBool
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		! !
